import os
import parsexcursor

class XCursorList:
    def __init__(self):
        self.curs = []
        self.trlist = {
            'v_double_arrow': '00008160000006810000408080010102',
            'h_double_arrow': '028006030e0e7ebffc7f7070c0600140',
            'fd_double_arrow': 'fcf1c3c7cd4491d801f1e1c78f100000',
            'bd_double_arrow': 'c7088f0f3e6c8088236ef8e1e3e70000',
            'sb_h_double_arrow': '14fef782d02440884392942c11205230',
            'sb_v_double_arrow': '2870a09082c103050810ffdffffe0204',
            'bottom_left_corner': '',
            'bottom_right_corner': '',
            'cross': '',
            'cross_reverse': '',
            'crosshair': '',
            'crossed_circle': '',
            'fleur': '',
            'hand': '',
            'left_side': '',
            'll_angle': '',
            'lr_angle': '',
            'pirate': '',
            'right_side': '',
            'top_left_corner': '',
            'top_right_corner': '',
            'top_side': '',
            'watch': '',
            'xterm': '',
            'hand1': '9d800788f1b08800ae810202380a0822',
            'hand2': 'e29285e634086352946a0e7090d73106',
            'crossed_circle': '03b6e0fcb3499374a867c041f52298f0',
            'move': '4498f0e0c1937ffe01fd06f973665830',
            'copy': '6407b0e94181790501fd1e167b474872',
            'link': '640fb0e74195791501fd1ed57b41487f',
            'left_ptr' : '',
            'left_ptr_watch': '3ecb610c1bf2410f44200f48c40d3599',
            'question_arrow': 'd9ce0ab605698f320427677b458ad60b',
            'left_ptr_watch': '08e8e1c95fe2fc01f976f1e063a24ccd' };
    def get_hash(self, curname):
        return self.trlist[curname];
    def get_known_cursors(self):
        return self.trlist.keys();
    def get_loaded_cursors(self):
        return self.curs.keys();
    def get_cursor(self, name):
        return self.curs[name]
    def save_to(self, dirname):
        for i in self.get_loaded_cursors():
            self.curs[i].write_to(dirname + i)
    def load_dir(self, dirname):
        self.curs = {}
        if (os.path.exists(dirname) == 0): # no such dir?
            return
        for i in os.listdir(dirname):
            # if os.path.exists(dirname + i):
            if os.path.islink(dirname + i) or os.path.isdir(dirname+i):
                continue
            locurs = parsexcursor.XCursorFile(dirname+i)
            if locurs.loaded_ok:
                self.curs[i] = locurs
                self.curs[i].islink =  os.path.islink(dirname + i)
                self.curs[i].rpath = os.path.basename(os.path.realpath(dirname + i))
            #else:
            #    print "non-existant: " + dirname + i;
        
